// ============================================================ //
#ifndef _SQ7653_IAP_CFG_H__
#define _SQ7653_IAP_CFG_H__
// ============================================================ //
void iap_boot( void);

/* -------------------------------------------------------------*/
// Normal boot start address
// 趨ʼλ
#define NORMAL_BOOT_ADDRESS		(0x4600)
/* -------------------------------------------------------------*/
// xf:
//      IAP LibraryYϴСsʹ1536Byte(600(hex))ĴС,
//      ʹ߾aʼλOĴλַ_ʼ,С춴λַ
//      LCF(Sample Link Command File)n֮boot_tableλַ
//      λͬ
/* -------------------------------------------------------------*/

/*--------------------------------------------------------------*/
// UART Interface Select
// ̬ѡһΪ IAP UART ʹ 

#define IAP_UART0_TX37_RX40            
//#define IAP_UART1_TX13_RX14            
//#define IAP_UART2_TX31_RX35            
/* -------------------------------------------------------------*/ 
// xf:
//      IAP_UART0_TX37_RX40: ʹP3.7lͶ˿,P4.0ն˿
//      IAP_UART1_TX13_RX14: ʹP1.3lͶ˿,P1.4ն˿
//      IAP_UART2_TX31_RX35: ʹP3.1lͶ˿,P3.5ն˿
// 
//      ͨ첽շ(UART)MBԔx:
//
//      1.IAP_UART_USED: ʹõUART
//      2.IAP_UART_TDBUF_ADR: UARTlݼĴַ(TDxBUF)
//      3.IAP_UART_RDBUF_ADR: UARTݼĴַ(RDxBUF)
//      4.IAP_UART_SR_ADR: UART״̬Ĵַ(UARTxSR)
//      5.IAP_UART_DR_ADR: UARTʼĴַ(UARTxDR)
//      6.IAP_UART_CR1_ADR: UARTƼĴ1ַ(UARTxCR1)
//      7.IAP_UART_CR2_ADR: UARTƼĴ2ַ(UARTxCR2)
/* -------------------------------------------------------------*/

/* -------------------------------------------------------------*/
// Baud Rate Select
// ̬ѡһΪ IAP UART Baudrate Speedʹ

 #define BAUDRATE_115200
// #define BAUDRATE_57600
// #define BAUDRATE_38400
// #define BAUDRATE_19200
// #define BAUDRATE_9600
/*--------------------------------------------------------------*/
// xf:
//      BAUDRATE_115200: Oͨ첽շ֮շʞ115200
//      BAUDRATE_57600:  Oͨ첽շ֮շʞ57600
//      BAUDRATE_38400:  Oͨ첽շ֮շʞ38400
//      BAUDRATE_19200:  Oͨ첽շ֮շʞ19200
//      BAUDRATE_9600:   Oͨ첽շ֮շʞ9600
//
//      ͨ첽շ֮շ(baud rate)MBԔx:
//
//      1.BAUDRATE_DR_VALUE: ʼĴ֮Oֵ
//      2.BAUDRATE_RTSEL_VALUE: RTʱ֮Oֵ
/*--------------------------------------------------------------*/

/*--------------------------------------------------------------*/
// UART control setting (parity / stop bit / even)
// O 1. (/o)żУ
//      2. (/ż)żУ
//      3. Ͷ˽λ
//      4. ն˽λ
//  
#define UART_CR1_VALUE          (0x00)
#define UART_CR2_VALUE          (0x00)
/*--------------------------------------------------------------*/
// 1:ożУ,Ͷ˽λ1λ,ն˽λ1λ
//      UART_CR1_VALUE = 0x00
//      UART_CR2_VALUE = 0x00
//
// 2:ożУ,Ͷ˽λ2λ,ն˽λ2λ
//      UART_CR1_VALUE = 0x20
//      UART_CR2_VALUE = 0x01
//
// 3:żУ,żУ,Ͷ˽λ1λ,ն˽λ1λ
//      UART_CR1_VALUE = 0x08
//      UART_CR2_VALUE = 0x00
//
// 4:żУ,żУ,Ͷ˽λ2λ,ն˽λ2λ
//      UART_CR1_VALUE = 0x28
//      UART_CR2_VALUE = 0x01
//
// 5:żУ,żżУ,Ͷ˽λ1λ,ն˽λ1λ
//      UART_CR1_VALUE = 0x18
//      UART_CR2_VALUE = 0x00
//
// 6:żУ,żżУ,Ͷ˽λ2λ,ն˽λ2λ
//      UART_CR1_VALUE = 0x38
//      UART_CR2_VALUE = 0x01
/* -------------------------------------------------------------*/

/* -------------------------------------------------------------*/
// Enable Boot PIN setting: 
// ̬ѡһΪ IAP Boot ДǷʹ

 #define IAP_BOOT_PIN_P00
// #define IAP_BOOT_PIN_P01
// #define IAP_BOOT_PIN_P02
// #define IAP_BOOT_PIN_P03
// #define IAP_BOOT_PIN_P04
// #define IAP_BOOT_PIN_P05 
// #define IAP_BOOT_PIN_P06 
// #define IAP_BOOT_PIN_P07 
// #define IAP_BOOT_PIN_P10
// #define IAP_BOOT_PIN_P11
// #define IAP_BOOT_PIN_P12
// #define IAP_BOOT_PIN_P13
// #define IAP_BOOT_PIN_P14
// #define IAP_BOOT_PIN_P15 
// #define IAP_BOOT_PIN_P16 
// #define IAP_BOOT_PIN_P17
// #define IAP_BOOT_PIN_P30
// #define IAP_BOOT_PIN_P31
// #define IAP_BOOT_PIN_P35 
// #define IAP_BOOT_PIN_P36 
// #define IAP_BOOT_PIN_P37
// #define IAP_BOOT_PIN_P40
// #define IAP_BOOT_PIN_P41
/* -------------------------------------------------------------*/
// xf:
//      Ӷ˿ڽMBԔO:
//      1.IAP_BOOT_PIN_DI_REG:˿Ĵλַ(PxFC)
//      2.IAP_BOOT_PIN_PU_REG:˿ƼĴλַ(PxPU)
//      3.IAP_BOOT_PIN_PD_REG:˿ƼĴλַ(PxPD)
//      4.IAP_BOOT_PIN_BIT:˿Bitλֵ
/* -------------------------------------------------------------*/

/* -------------------------------------------------------------*/
// IAP boot pin default level:
// 趨 IAP Boot ˿(ʼ)λ
// ʼ(Default) Oλ(High) = 0x01;
//               Oλ(Low)  = 0x00;
#define IAP_BOOT_GPIO_DEFAULT_HIGH_LOW (0x00)
/* -------------------------------------------------------------*/

/* -------------------------------------------------------------*/
// IAP boot pin enable level
// 趨 IAP Boot ˿()λ
// (Enable)  Oλ(High) = 0x01;
//               Oλ(Low)  = 0x00;
#define IAP_BOOT_GPIO_ENABLE_HIGH_LOW  (0x01)
/* -------------------------------------------------------------*/

/* -------------------------------------------------------------*/

// IAP Boot related data structure
typedef struct
{	
	// Boot pin related
	volatile unsigned char	 *ptrBootPinDI;     // pointer to Boot GPIO Pin Function register
	volatile unsigned char	 *ptrBootPinPU;     // pointer to Boot GPIO Pin Pull-Up register
	volatile unsigned char	 *ptrBootPinPD;     // pointer to Boot GPIO Pin Pull-Down register
	volatile unsigned char    valBootPinBit;
	volatile unsigned char	 valBootDefaultHL; // pointer to Boot GPIO Default High/Low
	volatile unsigned char	 valBootEnableHL;  // pointer to Boot GPIO Enable High/Low
	
	// UART releted
	volatile unsigned char	 *ptrUartTDBUF;        // Pointer to UART Tx device buffer (ex. 0x001) 
	volatile unsigned char	 *ptrUartRDBUF;        // Pointer to UART Tx device buffer (ex. 0x001) 
	volatile unsigned char	 *ptrUartSR;        // UART status byte(bit0: TBFL 0:buffer empty,  1:buffer full) 
	volatile unsigned char	 *ptrUartDR;
	volatile unsigned char	 *ptrUartCR1;
	volatile unsigned char	 *ptrUartCR2;
	volatile unsigned char    valUartUSED;
	volatile unsigned char    valUartDR;
	volatile unsigned char    valUartCR1;
	volatile unsigned char    valUartCR2;
	volatile unsigned char    valUartRTSEL;
	
	// Memory address related
	unsigned int    norBootAddr;
	
}IAP_Define;


extern IAP_Define IAP_Dev_define;   // define IAP related registers & runtime variable


/* -------------------------------------------------------------*/
/* -------------------------------------------------------------*/
// Boot pin define register detail
#ifdef IAP_BOOT_PIN_P00
#define IAP_BOOT_PIN_DI_REG                      (0x00F0)       //P0FC register address
#define IAP_BOOT_PIN_PU_REG                      (0x0110)       //P0 Pull-Up register address
#define IAP_BOOT_PIN_PD_REG                      (0x0120)       //P0 Pull-Down register address
#define IAP_BOOT_PIN_BIT                         (0x01)
#endif

#ifdef IAP_BOOT_PIN_P01
#define IAP_BOOT_PIN_DI_REG                      (0x00F0)       //P0FC register address
#define IAP_BOOT_PIN_PU_REG                      (0x0110)       //P0 Pull-Up register address
#define IAP_BOOT_PIN_PD_REG                      (0x0120)       //P0 Pull-Down register address
#define IAP_BOOT_PIN_BIT                         (0x02)
#endif

#ifdef IAP_BOOT_PIN_P02
#define IAP_BOOT_PIN_DI_REG                      (0x00F0)       //P0FC register address
#define IAP_BOOT_PIN_PU_REG                      (0x0110)       //P0 Pull-Up register address
#define IAP_BOOT_PIN_PD_REG                      (0x0120)       //P0 Pull-Down register address
#define IAP_BOOT_PIN_BIT                         (0x04)
#endif

#ifdef IAP_BOOT_PIN_P03
#define IAP_BOOT_PIN_DI_REG                      (0x00F0)       //P0FC register address
#define IAP_BOOT_PIN_PU_REG                      (0x0110)       //P0 Pull-Up register address
#define IAP_BOOT_PIN_PD_REG                      (0x0120)       //P0 Pull-Down register address
#define IAP_BOOT_PIN_BIT                         (0x08)
#endif

#ifdef IAP_BOOT_PIN_P04
#define IAP_BOOT_PIN_DI_REG                      (0x00F0)       //P0FC register address
#define IAP_BOOT_PIN_PU_REG                      (0x0110)       //P0 Pull-Up register address
#define IAP_BOOT_PIN_PD_REG                      (0x0120)       //P0 Pull-Down register address
#define IAP_BOOT_PIN_BIT                         (0x10)
#endif

#ifdef IAP_BOOT_PIN_P05
#define IAP_BOOT_PIN_DI_REG                      (0x00F0)       //P0FC register address
#define IAP_BOOT_PIN_PU_REG                      (0x0110)       //P0 Pull-Up register address
#define IAP_BOOT_PIN_PD_REG                      (0x0120)       //P0 Pull-Down register address
#define IAP_BOOT_PIN_BIT                         (0x20)
#endif

#ifdef IAP_BOOT_PIN_P06
#define IAP_BOOT_PIN_DI_REG                      (0x00F0)       //P0FC register address
#define IAP_BOOT_PIN_PU_REG                      (0x0110)       //P0 Pull-Up register address
#define IAP_BOOT_PIN_PD_REG                      (0x0120)       //P0 Pull-Down register address
#define IAP_BOOT_PIN_BIT                         (0x40)
#endif

#ifdef IAP_BOOT_PIN_P07
#define IAP_BOOT_PIN_DI_REG                      (0x00F0)       //P0FC register address
#define IAP_BOOT_PIN_PU_REG                      (0x0110)       //P0 Pull-Up register address
#define IAP_BOOT_PIN_PD_REG                      (0x0120)       //P0 Pull-Down register address
#define IAP_BOOT_PIN_BIT                         (0x80)
#endif

#ifdef IAP_BOOT_PIN_P10
#define IAP_BOOT_PIN_DI_REG                      (0x00F1)       //P0FC register address
#define IAP_BOOT_PIN_PU_REG                      (0x0111)       //P0 Pull-Up register address
#define IAP_BOOT_PIN_PD_REG                      (0x0121)       //P0 Pull-Down register address
#define IAP_BOOT_PIN_BIT                         (0x01)
#endif

#ifdef IAP_BOOT_PIN_P11
#define IAP_BOOT_PIN_DI_REG                      (0x00F1)       //P0FC register address
#define IAP_BOOT_PIN_PU_REG                      (0x0111)       //P0 Pull-Up register address
#define IAP_BOOT_PIN_PD_REG                      (0x0121)       //P0 Pull-Down register address
#define IAP_BOOT_PIN_BIT                         (0x02)
#endif

#ifdef IAP_BOOT_PIN_P12
#define IAP_BOOT_PIN_DI_REG                      (0x00F1)       //P0FC register address
#define IAP_BOOT_PIN_PU_REG                      (0x0111)       //P0 Pull-Up register address
#define IAP_BOOT_PIN_PD_REG                      (0x0121)       //P0 Pull-Down register address
#define IAP_BOOT_PIN_BIT                         (0x04)
#endif

#ifdef IAP_BOOT_PIN_P13
#define IAP_BOOT_PIN_DI_REG                      (0x00F1)       //P0FC register address
#define IAP_BOOT_PIN_PU_REG                      (0x0111)       //P0 Pull-Up register address
#define IAP_BOOT_PIN_PD_REG                      (0x0121)       //P0 Pull-Down register address
#define IAP_BOOT_PIN_BIT                         (0x08)
#endif

#ifdef IAP_BOOT_PIN_P14
#define IAP_BOOT_PIN_DI_REG                      (0x00F1)       //P0FC register address
#define IAP_BOOT_PIN_PU_REG                      (0x0111)       //P0 Pull-Up register address
#define IAP_BOOT_PIN_PD_REG                      (0x0121)       //P0 Pull-Down register address
#define IAP_BOOT_PIN_BIT                         (0x10)
#endif

#ifdef IAP_BOOT_PIN_P15
#define IAP_BOOT_PIN_DI_REG                      (0x00F1)       //P0FC register address
#define IAP_BOOT_PIN_PU_REG                      (0x0111)       //P0 Pull-Up register address
#define IAP_BOOT_PIN_PD_REG                      (0x0121)       //P0 Pull-Down register address
#define IAP_BOOT_PIN_BIT                         (0x20)
#endif

#ifdef IAP_BOOT_PIN_P16
#define IAP_BOOT_PIN_DI_REG                      (0x00F1)       //P0FC register address
#define IAP_BOOT_PIN_PU_REG                      (0x0111)       //P0 Pull-Up register address
#define IAP_BOOT_PIN_PD_REG                      (0x0121)       //P0 Pull-Down register address
#define IAP_BOOT_PIN_BIT                         (0x40)
#endif

#ifdef IAP_BOOT_PIN_P17
#define IAP_BOOT_PIN_DI_REG                      (0x00F1)       //P0FC register address
#define IAP_BOOT_PIN_PU_REG                      (0x0111)       //P0 Pull-Up register address
#define IAP_BOOT_PIN_PD_REG                      (0x0121)       //P0 Pull-Down register address
#define IAP_BOOT_PIN_BIT                         (0x80)
#endif

#ifdef IAP_BOOT_PIN_P30
#define IAP_BOOT_PIN_DI_REG                      (0x00F3)       //P0FC register address
#define IAP_BOOT_PIN_PU_REG                      (0x0113)       //P0 Pull-Up register address
#define IAP_BOOT_PIN_PD_REG                      (0x0123)       //P0 Pull-Down register address
#define IAP_BOOT_PIN_BIT                         (0x01)
#endif

#ifdef IAP_BOOT_PIN_P31
#define IAP_BOOT_PIN_DI_REG                      (0x00F3)       //P0FC register address
#define IAP_BOOT_PIN_PU_REG                      (0x0113)       //P0 Pull-Up register address
#define IAP_BOOT_PIN_PD_REG                      (0x0123)       //P0 Pull-Down register address
#define IAP_BOOT_PIN_BIT                         (0x02)
#endif

#ifdef IAP_BOOT_PIN_P34
#define IAP_BOOT_PIN_DI_REG                      (0x00F3)       //P0FC register address
#define IAP_BOOT_PIN_PU_REG                      (0x0113)       //P0 Pull-Up register address
#define IAP_BOOT_PIN_PD_REG                      (0x0123)       //P0 Pull-Down register address
#define IAP_BOOT_PIN_BIT                         (0x10)
#endif

#ifdef IAP_BOOT_PIN_P35
#define IAP_BOOT_PIN_DI_REG                      (0x00F3)       //P0FC register address
#define IAP_BOOT_PIN_PU_REG                      (0x0113)       //P0 Pull-Up register address
#define IAP_BOOT_PIN_PD_REG                      (0x0123)       //P0 Pull-Down register address
#define IAP_BOOT_PIN_BIT                         (0x20)
#endif

#ifdef IAP_BOOT_PIN_P36
#define IAP_BOOT_PIN_DI_REG                      (0x00F3)       //P0FC register address
#define IAP_BOOT_PIN_PU_REG                      (0x0113)       //P0 Pull-Up register address
#define IAP_BOOT_PIN_PD_REG                      (0x0123)       //P0 Pull-Down register address
#define IAP_BOOT_PIN_BIT                         (0x40)
#endif

#ifdef IAP_BOOT_PIN_P37
#define IAP_BOOT_PIN_DI_REG                      (0x00F3)       //P0FC register address
#define IAP_BOOT_PIN_PU_REG                      (0x0113)       //P0 Pull-Up register address
#define IAP_BOOT_PIN_PD_REG                      (0x0123)       //P0 Pull-Down register address
#define IAP_BOOT_PIN_BIT                         (0x80)
#endif

#ifdef IAP_BOOT_PIN_P40
#define IAP_BOOT_PIN_DI_REG                      (0x00F4)       //P0FC register address
#define IAP_BOOT_PIN_PU_REG                      (0x0114)       //P0 Pull-Up register address
#define IAP_BOOT_PIN_PD_REG                      (0x0124)       //P0 Pull-Down register address
#define IAP_BOOT_PIN_BIT                         (0x01)
#endif

#ifdef IAP_BOOT_PIN_P41
#define IAP_BOOT_PIN_DI_REG                      (0x00F4)       //P0FC register address
#define IAP_BOOT_PIN_PU_REG                      (0x0114)       //P0 Pull-Up register address
#define IAP_BOOT_PIN_PD_REG                      (0x0124)       //P0 Pull-Down register address
#define IAP_BOOT_PIN_BIT                         (0x02)
#endif

#ifdef IAP_BOOT_PIN_P42
#define IAP_BOOT_PIN_DI_REG                      (0x00F4)       //P0FC register address
#define IAP_BOOT_PIN_PU_REG                      (0x0114)       //P0 Pull-Up register address
#define IAP_BOOT_PIN_PD_REG                      (0x0124)       //P0 Pull-Down register address
#define IAP_BOOT_PIN_BIT                         (0x04)
#endif

#ifdef IAP_BOOT_PIN_P43
#define IAP_BOOT_PIN_DI_REG                      (0x00F4)       //P0FC register address
#define IAP_BOOT_PIN_PU_REG                      (0x0114)       //P0 Pull-Up register address
#define IAP_BOOT_PIN_PD_REG                      (0x0124)       //P0 Pull-Down register address
#define IAP_BOOT_PIN_BIT                         (0x08)
#endif

#ifdef IAP_BOOT_PIN_P44
#define IAP_BOOT_PIN_DI_REG                      (0x00F4)       //P0FC register address
#define IAP_BOOT_PIN_PU_REG                      (0x0114)       //P0 Pull-Up register address
#define IAP_BOOT_PIN_PD_REG                      (0x0124)       //P0 Pull-Down register address
#define IAP_BOOT_PIN_BIT                         (0x10)
#endif

#ifdef IAP_BOOT_PIN_P45
#define IAP_BOOT_PIN_DI_REG                      (0x00F4)       //P0FC register address
#define IAP_BOOT_PIN_PU_REG                      (0x0114)       //P0 Pull-Up register address
#define IAP_BOOT_PIN_PD_REG                      (0x0124)       //P0 Pull-Down register address
#define IAP_BOOT_PIN_BIT                         (0x20)
#endif

#ifdef IAP_BOOT_PIN_P46
#define IAP_BOOT_PIN_DI_REG                      (0x00F4)       //P0FC register address
#define IAP_BOOT_PIN_PU_REG                      (0x0114)       //P0 Pull-Up register address
#define IAP_BOOT_PIN_PD_REG                      (0x0124)       //P0 Pull-Down register address
#define IAP_BOOT_PIN_BIT                         (0x40)
#endif


/* -------------------------------------------------------------*/
/* -------------------------------------------------------------*/
// UART configure define register detail
#ifdef IAP_UART0_TX37_RX40
// UART0 --TXD0 (P3.7) ; RXD0 (P4.0)--------->
#define IAP_UART_USED           (0x00)
#define IAP_UART_TDBUF_ADR      (0x00A5)       // UART0 Tx buffer register address
#define IAP_UART_RDBUF_ADR      (0x00A4)       // UART0 Rx buffer register address
#define IAP_UART_SR_ADR         (0x00A3)       // UART0 Status register address
#define IAP_UART_DR_ADR         (0x00A2)
#define IAP_UART_CR1_ADR        (0x00A0)
#define IAP_UART_CR2_ADR        (0x00A1)
#endif
 
#ifdef IAP_UART1_TX13_RX14
// UART1 --TXD1 (P1.3) ; RXD1 (P1.4)--------->
#define IAP_UART_USED           (0x01)
#define IAP_UART_TDBUF_ADR      (0x00AB)       // UART1 Tx buffer register address
#define IAP_UART_RDBUF_ADR      (0x00AA)       // UART1 Rx buffer register address
#define IAP_UART_SR_ADR         (0x00A9)       // UART1 Status register address
#define IAP_UART_DR_ADR         (0x00A8)
#define IAP_UART_CR1_ADR        (0x00A6)
#define IAP_UART_CR2_ADR        (0x00A7)
#endif

#ifdef IAP_UART2_TX31_RX35
// UART2 --TXD2 (P3.1) ; RXD2 (P3.5)--------->
#define IAP_UART_USED           (0x02)
#define IAP_UART_TDBUF_ADR      (0x00B1)       // UART2 Tx buffer register address
#define IAP_UART_RDBUF_ADR      (0x00B0)       // UART2 Rx buffer register address
#define IAP_UART_SR_ADR         (0x00AF)       // UART2 Status register address
#define IAP_UART_DR_ADR         (0x00AE)
#define IAP_UART_CR1_ADR        (0x00AC)
#define IAP_UART_CR2_ADR        (0x00AD)
#endif

/* -------------------------------------------------------------*/
/* -------------------------------------------------------------*/
// baudrate define value detail
#ifdef BAUDRATE_115200
#define BAUDRATE_DR_VALUE       (0x0C)
#define BAUDRATE_RTSEL_VALUE    ((0x00) << 3)
#endif

#ifdef BAUDRATE_57600
#define BAUDRATE_DR_VALUE       (0x19)
#define BAUDRATE_RTSEL_VALUE    ((0x00) << 3)
#endif

#ifdef BAUDRATE_38400
#define BAUDRATE_DR_VALUE       (0x26)
#define BAUDRATE_RTSEL_VALUE    ((0x00) << 3)
#endif

#ifdef BAUDRATE_19200
#define BAUDRATE_DR_VALUE       (0x4D)
#define BAUDRATE_RTSEL_VALUE    ((0x00) << 3)
#endif

#ifdef BAUDRATE_9600
#define BAUDRATE_DR_VALUE       (0x92)
#define BAUDRATE_RTSEL_VALUE    ((0x04) << 3)
#endif

/* -------------------------------------------------------------*/
/* -------------------------------------------------------------*/

// ============================================================ //
#endif
// ============================================================ //

